declare type AimeServerSettings = {
    _token?: string;
    _wp_token?: string;
    _verbose: boolean;
    _player_id?: string;
    _player_class?: string;
    _player_parent?: string;
    _theme?: string;
    _public_folder?: string;
    _wp_user_id?: string;
    _wp_user_email?: string;
    _wp_site_url?: string;
    _wp_site_name?: string;
    _wp_site_description?: string;
    _wp_site_icon?: string;
    _wp_first_name?: string;
    _wp_last_name?: string;
    _channel_id?: string;
    _aime_server_url?: string;
};

export declare function getArticleButton(containerId: string, serverSettings: AimeServerSettings): Promise<void>;

/**
 *
 * @param filename
 * @param subfolder
 * @param type
 * @returns Base64 image
 */
export declare function getImageButton(containerId: string, serverSettings: AimeServerSettings): Promise<void>;

export declare const init: (serverSettings: AimeServerSettings) => Promise<void>;

/**
 *
 * @param filename
 * @param subfolder
 * @param type
 * @returns Base64 image
 */
export declare function rephraseButton(containerId: string, serverSettings: AimeServerSettings, text?: string): Promise<void>;

export declare const start: (serverSettings: AimeServerSettings) => Promise<void>;

export { }
