import {_x,_xd,XUI,_xlog} from "../client-lib/xpell/xpell.es.js"
import * as cjs from "../client-lib/aime-wp-js/aime-wp-js.es.js?ver=1.0.6"

// _x.verbose = true;
// _x.info()
// console.log(aimePlugin);
// console.log(_xd._o);
let _public_folder= _xd._o["aime_public_folder"];


//../client-lib/aime-wp-js/aime-wp-js.es.js
//http://localhost:8000/wp-content/plugins/aime-wp-plugin/client-lib/aime-wp-js/aime-wp-js.es.js
// const serverSettings ={
//     _token: undefined,
//     _verbose: true,
//     _player_id: "xplayer",
//     _player_class: "xplayer",
//     _player_parent: "aime-container",
//     _theme: "dark",
//     _public_folder:_public_folder,
//     _wp_user_id: "string",
//     _wp_user_email: "string",
//     _wp_site_url: "string",
//     _wp_site_name: "string",
//     _wp_site_description: "string",
//     _wp_site_icon: "string",
// }

// start(serverSettings); //start the aime-connect app
    // cjs.getArticleButton()
    _x.verbose = true;
    _xlog.log("registering Xpell-AI Gutenberg editor plugin")
    const serverSettings=_xd._o["server-settings"];
    await cjs.init(serverSettings)

    const { registerPlugin } = wp.plugins;
    const { BlockControls } = wp.blockEditor;
    const { withSelect, withDispatch } = wp.data;
    
    let subscriptionsSetUp = false;

    
    const AimeDropdownMenu = function(props) {
        const { selectedText, onRephrase } = props;

        const handleRephrase = function() {
        let popup =XUI.add({
            _type:"view",
            _id:"rephrase",
            style:"width: 870px; height: 616px; flex-shrink: 0;border-radius: 9px; border: 0.5px solid #FFF; background: #111416;",
            _text:"Test",
            _parent_element:"wpwrap"


        })
        };
        

        const dropdownButton = document.createElement('button');
        dropdownButton.classList.add('aime-rephrase-button');
        dropdownButton.innerText = 'Rephrase';
        // add style to button
        dropdownButton.style.backgroundColor = 'white';
        dropdownButton.style.color = 'black';
        // hight of button
        dropdownButton.style.height = '50px';
        // border radius
        dropdownButton.style.borderRadius = '5px';
        dropdownButton.onclick = handleRephrase;

        const dropdownMenu = document.createElement('div');
        dropdownMenu.classList.add('aime-dropdown-menu');
        dropdownMenu.appendChild(dropdownButton);

        // Function to add the dropdown menu

     
        const addDropdownMenu = function() {
           
            
            // console.log('Adding dropdown menu');
            const blockToolbar = document.querySelector('.block-editor-block-toolbar');
            if (blockToolbar) {
                // console.log('Block toolbar found');
                // Check if it's already added to avoid duplicates
                if (!document.querySelector('.aime-rephrase-button')) {
                    blockToolbar.appendChild(dropdownButton);
                    dropdownButton.onclick = function() {
                        // get block text content
                        const blockText = wp.data.select('core/block-editor').getSelectedBlock().attributes.content;
                        let text = blockText.originalHTML;
                        if(text === undefined){
                            text = blockText;
                        }
                        
                        
                        const serverSettings=_xd._o["server-settings"];
                        // change _player_parent to blockToolbar.id
                        serverSettings._player_parent = blockToolbar.id;
                        
              
                        cjs.rephraseButton(blockToolbar.id,serverSettings,text)

                        
                        
                     
                    };
                }
            }
        };
        // function to add to toolbar
        const addToolbar = function() {
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            // console.log(blockToolbar);
            blockToolbar.id = 'aime-toolbar';
            
            if (blockToolbar) {
                if (!document.querySelector('#get-article-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    document.addEventListener('article-gen', function(e) {
                        
                        // console.log(e.detail);
                        if(e.detail.text){
                            
                            // console.log(e.detail.text);
                            addNewBlockContent(e.detail.text);
                        }
                    });


                    
                    
    
                    cjs.getArticleButton(blockToolbar.id,serverSettings)


                    
                }
            }
        }
        const addToolbarImage = function() {
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            // console.log(blockToolbar);
            blockToolbar.id = 'aime-toolbar-image';
            
            if (blockToolbar) {
                if (!document.querySelector('#get-image-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    const addImage=async  ()=>{

                       const imageUrl= await getLastImage()  
                       
                       
                           if (imageUrl) {
                            
                               // create block with image
                               // addNewBlock(imageUrl,'core/image');
                               
                               addNewBlock(`<img src="${imageUrl}" />`);
                               document.removeEventListener('image-gen', addImage);

   
                               // insert image to block
                               
                           }
                           
                       }
                           
                       

                       document.addEventListener('image-gen', addImage)

                    
    
                    cjs.getImageButton(blockToolbar.id,serverSettings)
                    


                    
                }
            }
        }

        const rephraseButton =function(){
            
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            // console.log(blockToolbar);
            blockToolbar.id = 'aime-toolbar-repharse';
  
            
            if (blockToolbar) {
                if (!document.querySelector('#rephrase-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    // check if block selected
                    document.addEventListener('update-article',function(e){
                        if(e.detail.text){
                            e.detail.text.blocks.forEach(block => {
                                // const blockData ='<div>'+'<h1>'+block.title+'</h1> <p>' + block.content+'</p><div/>';
                                addNewBlock(block.title,'core/heading');
                                addNewBlock( block.content);
                            });

                            // console.log(e.detail.text);
                            // for(let i=0; i<e.detail.text.length; i++){
                            //     addNewBlock(e.detail.text[i]);
                            // }
                            
                            
                  

                        }
                        
                    })

                    
   
                    document.addEventListener('rephrase-done', function(e) {
                        // console.log(e.detail);
                        if(e.detail.text){                            
                            replaceBlockContent(e.detail.text);
                        }
                        
                        
                    })
                    // document.addEventListener('article-gen-ref', function(e) {
                    //     console.log("hereeeee");
                        
                    //     // console.log(e.detail);
                    //     if(e.detail.text){
                            
                    //         // console.log(e.detail.text);
                    //         addNewBlockContent(e.detail.text);
                    //     }
                    // });
              
                    cjs.rephraseButton(blockToolbar.id,serverSettings)
                    


                    
                }
            }

        }
        const getLastImage = async () => {
            const response = await fetch('/wp-json/wp/v2/media?per_page=1&orderby=date&order=desc');
            const data = await response.json();
            
        
            if (data.length > 0) {
                const lastImage = data[0].source_url;
                // console.log('Last image URL:', lastImage);
                return lastImage;
            }
        
            return null;
        };
        
  
        
        
        
        const paragarphButton =function(){
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            // console.log(blockToolbar);
            blockToolbar.id = 'aime-toolbar-paragarph';
            
            if (blockToolbar) {
                if (!document.querySelector('#paragarph-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;


                    document.addEventListener('paragraph-done', function(e) {
                        // console.log(e.detail);
                        if(e.detail.text){
                            // console.log(e.detail.text);
                            
                            // addNewBlockContent(e.detail.text);
                        }
                        
                        
                    })
   
    
                    cjs.paragarphButton(blockToolbar.id,serverSettings)


                    
                }
            }

        }
        
        function insertTextAtCursor(text) {
            const { dispatch, select } = wp.data;
            const { getBlockSelectionEnd, getSelectedBlock } = select('core/block-editor');
            const { updateBlock } = dispatch('core/block-editor');
            const { RichText } = wp.blockEditor || wp.editor; // Depending on WP version
            const block = getSelectedBlock();
            if(!block) return;
            const { content } = block.attributes;
            const { start, end } = getBlockSelectionEnd(block.clientId);
            const before = content.substring(0, start);
            const after = content.substring(end);
            const newText = before + text + after;
            updateBlock(block.clientId, { content: newText });
            RichText.insert( block.clientId, newText );



        }
        function replaceBlockContent(newText) {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId, getBlock } = select('core/block-editor');
            const { updateBlockAttributes } = dispatch('core/block-editor');
            // Get the client ID of the selected block
            const selectedBlockClientId = getSelectedBlockClientId();
            if (!selectedBlockClientId) return;
    
            // Get the currently selected block
            const block = getBlock(selectedBlockClientId);
            if (!block) return;
    
            // Replace the block's content with the new text
            updateBlockAttributes(selectedBlockClientId, { content: newText });
        }
        function addNewBlock(newText,blockType='core/paragraph') {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId } = select('core/block-editor');
            const { insertBlock } = dispatch('core/block-editor');
        
            // Define the new block attributes
            const newBlock = wp.blocks.createBlock(blockType, {
                content: newText,
            });
           // if newText is duplicate of last block content then return
           
            
            
            insertBlock(newBlock);

      
                

        }
        function addNewBlockContent(newText) {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId } = select('core/block-editor');
            const { insertBlock } = dispatch('core/block-editor');
        
            // Define the new block attributes
            const newBlock = wp.blocks.createBlock('core/paragraph', {
                content: newText,
            });
            
        
            // Get the client ID of the selected block
            const selectedBlockClientId = getSelectedBlockClientId();
            

            
            
            
            // Insert the new block after the selected block (or at the end if no block is selected)
            if (selectedBlockClientId) {
                
                insertBlock(newBlock, undefined, selectedBlockClientId);
            } else {
                // If no block is selected, insert the block at the end
                insertBlock(newBlock);
                // console.log('No block selected',newBlock);
                
            }
        }
    
        
        
        

 
        
        // Subscribe to changes in the editor
        // console.log('Subscribing to changes in the editor');
        
        wp.data.subscribe(addDropdownMenu);
        wp.data.subscribe(addToolbar);
        wp.data.subscribe(addToolbarImage);
        wp.data.subscribe(rephraseButton);
        // wp.data.subscribe(aimeButton);

        // wp.data.subscribe(paragarphButton);
        
    };

    const mapSelectToProps = function(select) {
        const { getSelectedBlock } = select('core/block-editor');
        const selectedBlock = getSelectedBlock();
        return {
            selectedText: selectedBlock ? selectedBlock.attributes.content : '',
        };
    };

    const mapDispatchToProps = function(dispatch) {
        return {
            onRephrase: function(newText) {
                dispatch('core/block-editor').updateBlockAttributes(newText);
            },
            // onToolBar: function() {
            //     dispatch('core/block-editor').updateBlockAttributes(newText);
            // }
        };
    };

    const EnhancedDropdownMenu = withSelect(mapSelectToProps)(withDispatch(mapDispatchToProps)(AimeDropdownMenu));

    registerPlugin('aime-ai-plugin', {
        render: EnhancedDropdownMenu    });

